#ifndef _MPL_CONCEPTS_ASSOCIATIVE_SEQUENCE
#define _MPL_CONCEPTS_ASSOCIATIVE_SEQUENCE

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/concept/assert.hpp>
#include <boost/concept_check.hpp>

#include "forward_sequence.hpp"

#include <boost/mpl/has_key.hpp>
#include <boost/mpl/count.hpp>
#include <boost/mpl/order.hpp>
#include <boost/mpl/at.hpp>
#include <boost/mpl/key_type.hpp>
#include <boost/mpl/value_type.hpp>
#include <boost/mpl/bool.hpp>

namespace boost {
namespace mpl {

namespace detail {
template<typename S2, typename B>
struct is_empty {};
template<typename S2>
struct is_empty<S2, boost::mpl::false_> {
    typedef typename front<S2>::type front_type;
    typedef typename key_type<S2, front_type>::type K;
    typedef typename value_type<S2, front_type>::type t4;
    typedef typename at<S2, K>::type t5;
    typedef typename count<S2, front_type>::type t2;
    BOOST_CONCEPT_ASSERT(( IntegralConstant<t2> ));
    typedef typename order<S2, front_type>::type t3;
    BOOST_CONCEPT_ASSERT(( IntegralConstant<t3> ));
    // hmmm - the following is documented but doesn't seem to exist
    // int header
    // typedef typename at<S2, K, D>::type t5;
};
} // detail

template<typename S>
struct AssociativeSequence {
    BOOST_CONCEPT_ASSERT(( ForwardSequence<S> ));
    typedef int X; // actually any type

    typedef typename has_key<S, int>::type t1;
    BOOST_CONCEPT_ASSERT(( BooleanIntegralConstant<t1> ));
    typedef typename boost::mpl::detail::is_empty<
        S,
        typename empty<S>::type
    > type;
};

} // mpl
} // boost

#endif // _MPL_CONCEPTS_ASSOCIATIVE_SEQUENCE
