#ifndef _MPL_CONCEPTS_BIDIRECTIONAL_ITERATOR
#define _MPL_CONCEPTS_BIDIRECTIONAL_ITERATOR

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/concept/assert.hpp>
#include <boost/mpl/assert.hpp>
#include <boost/type_traits/is_convertible.hpp>
#include <boost/type_traits/is_same.hpp>

#include "forward_iterator.hpp"
#include <boost/mpl/prior.hpp>
#include <boost/mpl/next.hpp>
#include <boost/mpl/vector/aux_/iterator.hpp>

namespace boost {
namespace mpl {

template<typename I>
struct BiDirectionalIterator {
    BOOST_CONCEPT_ASSERT(( ForwardIterator<I> ));

    template<typename I2, typename B>
    struct is_end {};

    template<typename I2>
    struct is_end<I2, false_> {
        typedef typename next<I2>::type t2;
        BOOST_CONCEPT_ASSERT(( BiDirectionalIterator<t2> ));
        // note: we can't do this because we can't determine in 
        // general way that were not at the end!
        //BOOST_MPL_ASSERT((
        //    boost::is_same<
        //        I2,
        //        prior< t2 >::type
        //   >
        //));
        // note: we can't check the following because we can't
        // determine that we're not at the beginning
        //BOOST_MPL_ASSERT((
        //    boost::is_same<
        //        I,
        //        next< prior<I>::type >::type
        //    >
        //));
    };
    BOOST_MPL_ASSERT(( 
        boost::is_convertible< 
            typename I::category,
            bidirectional_iterator_tag
        >
    ));
};

} // mpl
} // boost

#endif // _MPL_CONCEPTS_BIDIRECTIONAL_ITERATOR
