#ifndef _MPL_CONCEPTS_BOOLEAN_INTEGRAL_CONSTANT
#define _MPL_CONCEPTS_BOOLEAN_INTEGRAL_CONSTANT

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/concept_check.hpp>

namespace boost {
namespace mpl {

template<typename B>
struct BooleanIntegralConstant {
    typedef boost::mpl::integral_c_tag tag;
    typedef bool value_type;
    typedef bool type;
    void test(bool b); 
    BOOST_CONCEPT_USAGE(BooleanIntegralConstant)
    {
        bool b = B();
        test(b); // to suppress unused variable message
    }
};

} // mpl
} // boost

#endif // _MPL_CONCEPTS_BOOLEAN_INTEGRAL_CONSTANT
