#ifndef _MPL_CONCEPTS_FORWARD_ITERATOR
#define _MPL_CONCEPTS_FORWARD_ITERATOR

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/concept/assert.hpp>
#include <boost/mpl/assert.hpp>
#include <boost/type_traits/is_convertible.hpp>
#include <boost/type_traits/is_same.hpp>

#include <boost/mpl/deref.hpp>
#include <boost/mpl/next.hpp>
#include <boost/mpl/iterator_category.hpp>
#include <boost/mpl/iterator_tags.hpp>

namespace boost {
namespace mpl {

template<typename I>
struct ForwardIterator {
    /* note: we can't do this because there is not way
     * to determine for all iterators whether or not we're
     * at the end
     */
    /*
    template<typename I2, typename B>
    struct is_end {};
    template<typename I2>
    struct is_end<I2, false_> {
        typedef typename deref<I2>::type t1;
        typedef typename next<I2>::type t2;
        BOOST_CONCEPT_ASSERT(( ForwardIterator<t2> ));
    };

    typedef ForwardIterator::is_end<
        I,
        typename boost::is_same<
            l_iter<l_end>, 
            I
        >
    > type;
    */
    BOOST_MPL_ASSERT(( 
        is_convertible< 
            typename I::category,
            forward_iterator_tag
        >
    ));
};

} // mpl
} // boost

#endif // _MPL_CONCEPTS_FORWARD_ITERATOR
