#ifndef _MPL_CONCEPTS_INTEGRAL_CONSTANT
#define _MPL_CONCEPTS_INTEGRAL_CONSTANT

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/concept_check.hpp>
#include <boost/mpl/next.hpp>
#include <boost/mpl/prior.hpp>

namespace boost {
namespace mpl {

template<typename I>
struct IntegralConstant {
    typedef typename I::tag tag;
    typedef typename I::value_type value_type;
    typedef typename I::type type;
    BOOST_CONCEPT_USAGE(IntegralConstant)
    {
        value_type c = I();
        same(v, I::value);
        c = 0; // to avoid warning unused type
    }
    value_type v;
    typedef typename next<I>::type next_type;
    typedef typename prior<I>::type prior_type;
    template<typename T>
    bool same(const T & t1, const T & t2);
};

} // mpl
} // boost

#endif // _MPL_CONCEPTS_INTEGRAL_CONSTANT
