///////////////////////////////////////////////////////////
// verify forward sequence constant concepts

#include "concepts/forward_sequence.hpp"

#include <boost/mpl/list.hpp>

void test_list_sequence(){
    BOOST_CONCEPT_ASSERT(( boost::mpl::ForwardSequence<
        boost::mpl::list<int, char>
    > ));
}

#include <boost/mpl/list_c.hpp>

void test_list_c_sequence(){
    BOOST_CONCEPT_ASSERT(( boost::mpl::ForwardSequence<
        boost::mpl::list_c<int, 1, 2, 3, 4, 5>
    > ));
}

///////////////////////////////////////////////////////////
// verify associative sequence constant concepts

#include "concepts/associative_sequence.hpp"

#include <boost/mpl/set.hpp>

void test_set_sequence(){
    BOOST_CONCEPT_ASSERT(( boost::mpl::AssociativeSequence<
        boost::mpl::set<int, char>
    > ));
}

/* note: fails test on count<Sequence, Type>.  I suspect
 * error in set_c implementation !
 */
/*
#include <boost/mpl/set_c.hpp>

void test_set_c_sequence(){
    BOOST_CONCEPT_ASSERT(( boost::mpl::AssociativeSequence<
        boost::mpl::set_c<int, 0>
    > ));
}
*/


#include <boost/mpl/map.hpp>
#include <boost/mpl/pair.hpp>

void test_map_sequence(){
    BOOST_CONCEPT_ASSERT(( boost::mpl::AssociativeSequence<
        boost::mpl::map< 
            boost::mpl::pair<int, char>,
            boost::mpl::pair<long, char>
        >
    > ));
}

///////////////////////////////////////////////////////////
// verify metafunction concepts


///////////////////////////////////////////////////////////
// verify metafunction class concepts
